stages:
  - build_and_deploy

frontend_build:
  stage: build_and_deploy
  script:
    - |
      echo "Running frontend_build"
      sleep 10

frontend_deploy:
  stage: build_and_deploy
  script:
    - |
      echo "Running frontend_deploy"
      sleep 5
  needs:
    - frontend_build
    - e2e_test

backend_build:
  stage: build_and_deploy
  script:
    - |
      echo "Running backend_build"
      sleep 30

backend_deploy:
  stage: build_and_deploy
  script:
    - |
      echo "Running backend_deploy"
      sleep 5
  needs:
    - backend_build
    - e2e_test

e2e_test:
  stage: build_and_deploy
  script:
    - |
      echo "Running e2e_test"
  needs:
    - frontend_build
    - backend_build
